# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GerritTrigger1(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'create_time_in_micros': 'int',
        'link': 'str',
        'project_id': 'str',
        'update_time_in_micros': 'int',
        'branch': 'str',
        'configurations': 'list[GerritTriggerGerritEventConfiguration]',
        'created_at': 'str',
        'created_by': 'str',
        'description': 'str',
        'enabled': 'bool',
        'exclusions': 'list[GerritTriggerFileFilter]',
        'gerrit_project': 'str',
        'id': 'str',
        'inclusions': 'list[GerritTriggerFileFilter]',
        'listener': 'str',
        'name': 'str',
        'prioritize_exclusion': 'bool',
        'project': 'str',
        'updated_at': 'str',
        'updated_by': 'str',
        'version': 'str'
    }

    attribute_map = {
        'create_time_in_micros': '_createTimeInMicros',
        'link': '_link',
        'project_id': '_projectId',
        'update_time_in_micros': '_updateTimeInMicros',
        'branch': 'branch',
        'configurations': 'configurations',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'description': 'description',
        'enabled': 'enabled',
        'exclusions': 'exclusions',
        'gerrit_project': 'gerritProject',
        'id': 'id',
        'inclusions': 'inclusions',
        'listener': 'listener',
        'name': 'name',
        'prioritize_exclusion': 'prioritizeExclusion',
        'project': 'project',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'version': 'version'
    }

    def __init__(self, create_time_in_micros=None, link=None, project_id=None, update_time_in_micros=None, branch=None, configurations=None, created_at=None, created_by=None, description=None, enabled=None, exclusions=None, gerrit_project=None, id=None, inclusions=None, listener=None, name=None, prioritize_exclusion=None, project=None, updated_at=None, updated_by=None, version=None):  # noqa: E501
        """GerritTrigger1 - a model defined in Swagger"""  # noqa: E501
        self._create_time_in_micros = None
        self._link = None
        self._project_id = None
        self._update_time_in_micros = None
        self._branch = None
        self._configurations = None
        self._created_at = None
        self._created_by = None
        self._description = None
        self._enabled = None
        self._exclusions = None
        self._gerrit_project = None
        self._id = None
        self._inclusions = None
        self._listener = None
        self._name = None
        self._prioritize_exclusion = None
        self._project = None
        self._updated_at = None
        self._updated_by = None
        self._version = None
        self.discriminator = None
        if create_time_in_micros is not None:
            self.create_time_in_micros = create_time_in_micros
        if link is not None:
            self.link = link
        if project_id is not None:
            self.project_id = project_id
        if update_time_in_micros is not None:
            self.update_time_in_micros = update_time_in_micros
        if branch is not None:
            self.branch = branch
        if configurations is not None:
            self.configurations = configurations
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if description is not None:
            self.description = description
        if enabled is not None:
            self.enabled = enabled
        if exclusions is not None:
            self.exclusions = exclusions
        if gerrit_project is not None:
            self.gerrit_project = gerrit_project
        if id is not None:
            self.id = id
        if inclusions is not None:
            self.inclusions = inclusions
        if listener is not None:
            self.listener = listener
        self.name = name
        if prioritize_exclusion is not None:
            self.prioritize_exclusion = prioritize_exclusion
        if project is not None:
            self.project = project
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if version is not None:
            self.version = version

    @property
    def create_time_in_micros(self):
        """Gets the create_time_in_micros of this GerritTrigger1.  # noqa: E501

        This field is provided for backward compatibility. Contains the same value as the 'createdAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :return: The create_time_in_micros of this GerritTrigger1.  # noqa: E501
        :rtype: int
        """
        return self._create_time_in_micros

    @create_time_in_micros.setter
    def create_time_in_micros(self, create_time_in_micros):
        """Sets the create_time_in_micros of this GerritTrigger1.

        This field is provided for backward compatibility. Contains the same value as the 'createdAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :param create_time_in_micros: The create_time_in_micros of this GerritTrigger1.  # noqa: E501
        :type: int
        """

        self._create_time_in_micros = create_time_in_micros

    @property
    def link(self):
        """Gets the link of this GerritTrigger1.  # noqa: E501

        Partial URL that provides details of the resource.  # noqa: E501

        :return: The link of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._link

    @link.setter
    def link(self, link):
        """Sets the link of this GerritTrigger1.

        Partial URL that provides details of the resource.  # noqa: E501

        :param link: The link of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._link = link

    @property
    def project_id(self):
        """Gets the project_id of this GerritTrigger1.  # noqa: E501

        Contains project id of the entity  # noqa: E501

        :return: The project_id of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this GerritTrigger1.

        Contains project id of the entity  # noqa: E501

        :param project_id: The project_id of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def update_time_in_micros(self):
        """Gets the update_time_in_micros of this GerritTrigger1.  # noqa: E501

        This field is provided for backward compatibility. Contains the same value as the 'updatedAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :return: The update_time_in_micros of this GerritTrigger1.  # noqa: E501
        :rtype: int
        """
        return self._update_time_in_micros

    @update_time_in_micros.setter
    def update_time_in_micros(self, update_time_in_micros):
        """Sets the update_time_in_micros of this GerritTrigger1.

        This field is provided for backward compatibility. Contains the same value as the 'updatedAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :param update_time_in_micros: The update_time_in_micros of this GerritTrigger1.  # noqa: E501
        :type: int
        """

        self._update_time_in_micros = update_time_in_micros

    @property
    def branch(self):
        """Gets the branch of this GerritTrigger1.  # noqa: E501

        Gerrit Project Branch on which the change has to be monitored.  # noqa: E501

        :return: The branch of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._branch

    @branch.setter
    def branch(self, branch):
        """Sets the branch of this GerritTrigger1.

        Gerrit Project Branch on which the change has to be monitored.  # noqa: E501

        :param branch: The branch of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._branch = branch

    @property
    def configurations(self):
        """Gets the configurations of this GerritTrigger1.  # noqa: E501

        The configuration of an Gerrit Event.  # noqa: E501

        :return: The configurations of this GerritTrigger1.  # noqa: E501
        :rtype: list[GerritTriggerGerritEventConfiguration]
        """
        return self._configurations

    @configurations.setter
    def configurations(self, configurations):
        """Sets the configurations of this GerritTrigger1.

        The configuration of an Gerrit Event.  # noqa: E501

        :param configurations: The configurations of this GerritTrigger1.  # noqa: E501
        :type: list[GerritTriggerGerritEventConfiguration]
        """

        self._configurations = configurations

    @property
    def created_at(self):
        """Gets the created_at of this GerritTrigger1.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 with time zone  # noqa: E501

        :return: The created_at of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this GerritTrigger1.

        Date when the entity was created. The date is in ISO 8601 with time zone  # noqa: E501

        :param created_at: The created_at of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this GerritTrigger1.  # noqa: E501

        The user that created this entity  # noqa: E501

        :return: The created_by of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this GerritTrigger1.

        The user that created this entity  # noqa: E501

        :param created_by: The created_by of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def description(self):
        """Gets the description of this GerritTrigger1.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this GerritTrigger1.

        A human-friendly description.  # noqa: E501

        :param description: The description of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def enabled(self):
        """Gets the enabled of this GerritTrigger1.  # noqa: E501

        Indicates that this trigger will be addressed on receiving respective events.  # noqa: E501

        :return: The enabled of this GerritTrigger1.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this GerritTrigger1.

        Indicates that this trigger will be addressed on receiving respective events.  # noqa: E501

        :param enabled: The enabled of this GerritTrigger1.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def exclusions(self):
        """Gets the exclusions of this GerritTrigger1.  # noqa: E501

        Provide file exclusions as conditions for the trigger.  # noqa: E501

        :return: The exclusions of this GerritTrigger1.  # noqa: E501
        :rtype: list[GerritTriggerFileFilter]
        """
        return self._exclusions

    @exclusions.setter
    def exclusions(self, exclusions):
        """Sets the exclusions of this GerritTrigger1.

        Provide file exclusions as conditions for the trigger.  # noqa: E501

        :param exclusions: The exclusions of this GerritTrigger1.  # noqa: E501
        :type: list[GerritTriggerFileFilter]
        """

        self._exclusions = exclusions

    @property
    def gerrit_project(self):
        """Gets the gerrit_project of this GerritTrigger1.  # noqa: E501

        Gerrit Project which is to be monitored for the change.  # noqa: E501

        :return: The gerrit_project of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._gerrit_project

    @gerrit_project.setter
    def gerrit_project(self, gerrit_project):
        """Sets the gerrit_project of this GerritTrigger1.

        Gerrit Project which is to be monitored for the change.  # noqa: E501

        :param gerrit_project: The gerrit_project of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._gerrit_project = gerrit_project

    @property
    def id(self):
        """Gets the id of this GerritTrigger1.  # noqa: E501

        The id of this resource.  # noqa: E501

        :return: The id of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GerritTrigger1.

        The id of this resource.  # noqa: E501

        :param id: The id of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def inclusions(self):
        """Gets the inclusions of this GerritTrigger1.  # noqa: E501

        Provide file inclusions as conditions for the trigger.  # noqa: E501

        :return: The inclusions of this GerritTrigger1.  # noqa: E501
        :rtype: list[GerritTriggerFileFilter]
        """
        return self._inclusions

    @inclusions.setter
    def inclusions(self, inclusions):
        """Sets the inclusions of this GerritTrigger1.

        Provide file inclusions as conditions for the trigger.  # noqa: E501

        :param inclusions: The inclusions of this GerritTrigger1.  # noqa: E501
        :type: list[GerritTriggerFileFilter]
        """

        self._inclusions = inclusions

    @property
    def listener(self):
        """Gets the listener of this GerritTrigger1.  # noqa: E501

        Gerrit Listener which will receive the events for this trigger.  # noqa: E501

        :return: The listener of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._listener

    @listener.setter
    def listener(self, listener):
        """Sets the listener of this GerritTrigger1.

        Gerrit Listener which will receive the events for this trigger.  # noqa: E501

        :param listener: The listener of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._listener = listener

    @property
    def name(self):
        """Gets the name of this GerritTrigger1.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :return: The name of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GerritTrigger1.

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :param name: The name of this GerritTrigger1.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def prioritize_exclusion(self):
        """Gets the prioritize_exclusion of this GerritTrigger1.  # noqa: E501

        Prioritize Exclusion ensures that Pipelines are not triggered even if any of the files in a commit match the specified files in the exclusion paths or regex.  # noqa: E501

        :return: The prioritize_exclusion of this GerritTrigger1.  # noqa: E501
        :rtype: bool
        """
        return self._prioritize_exclusion

    @prioritize_exclusion.setter
    def prioritize_exclusion(self, prioritize_exclusion):
        """Sets the prioritize_exclusion of this GerritTrigger1.

        Prioritize Exclusion ensures that Pipelines are not triggered even if any of the files in a commit match the specified files in the exclusion paths or regex.  # noqa: E501

        :param prioritize_exclusion: The prioritize_exclusion of this GerritTrigger1.  # noqa: E501
        :type: bool
        """

        self._prioritize_exclusion = prioritize_exclusion

    @property
    def project(self):
        """Gets the project of this GerritTrigger1.  # noqa: E501

        The project this entity belongs to.  # noqa: E501

        :return: The project of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this GerritTrigger1.

        The project this entity belongs to.  # noqa: E501

        :param project: The project of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def updated_at(self):
        """Gets the updated_at of this GerritTrigger1.  # noqa: E501

        Date when the entity was last updated. The date is in ISO 8601 with time zone.  # noqa: E501

        :return: The updated_at of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this GerritTrigger1.

        Date when the entity was last updated. The date is in ISO 8601 with time zone.  # noqa: E501

        :param updated_at: The updated_at of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this GerritTrigger1.  # noqa: E501

        The user that last updated this entity  # noqa: E501

        :return: The updated_by of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this GerritTrigger1.

        The user that last updated this entity  # noqa: E501

        :param updated_by: The updated_by of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def version(self):
        """Gets the version of this GerritTrigger1.  # noqa: E501

        Version of the resource.  # noqa: E501

        :return: The version of this GerritTrigger1.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this GerritTrigger1.

        Version of the resource.  # noqa: E501

        :param version: The version of this GerritTrigger1.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GerritTrigger1, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GerritTrigger1):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
